import { superValidate, fail, message } from 'sveltekit-superforms';
import { zod } from 'sveltekit-superforms/adapters';
import { z } from 'zod';

export const formSchema = z.object({
  file: z
    .instanceof(File, { message: 'Ladda in en fil.' })
    .refine((f) => f.size < 1024 * 1024 * 15, 'Max 15 MB kan laddas in.')
});

export const load = async () => {
  return {
    form: await superValidate(zod(formSchema))
  }
};

export const actions = {
  default: async ({ request }) => {
    const form = await superValidate(request, zod(formSchema));

    if (!form.valid) {
      console.log(form)
      return fail(400, { form });
    }

    // TODO: Do something with the image
    console.log(form.data.file);

    return message(form, 'You have uploaded a valid file!');
  }
};

export type FormSchema = typeof formSchema;
