import { db } from "../db/main"
import { type Shortform } from "../db/main"
import { shortforms } from "../lib/stores.svelte"

export async function cacheShortform(shortform: Shortform) {
	if (shortforms.cache.has(shortform.shortform)) {
		const existing = shortforms.cache.get(shortform.shortform)
		const existingShortformList = await db.lists.where("id").equals(existing.listid).first()
		const newShortformList = await db.lists.where("id").equals(shortform.listid).first()

		if (newShortformList >= existingShortformList) {
			shortforms.cache.set(shortform.shortform, shortform)
		}

	} else {
		shortforms.cache.set(shortform.shortform, shortform)
	}
}

export function cacheShortforms(lists: Array<number> = []) {
	let cache = new Map();
	// console.log("Caching shortforms with lists:", lists);

	var n = 0;
	var shortforms_length = 0;
	var phrases_length = 0;
	if (lists.length < 1) {
		default_shortforms.map((sf: ShortformExportType) => {
			cache.set(sf.sf, { phrase: sf.p, last: sf.u });
			/*     
				n += 1;
				shortforms_length += sf.sf.length;
				phrases_length += sf.p.length;
			*/
		});
		/*
		console.log("Average shortform length:", shortforms_length / n);
		console.log("Average phrases length:", phrases_length / n);
		*/
	}
	else {
		lists.forEach(listid => {
			console.log("looking up shortforms for this listid:", listid)
			db.shortforms.where("listid").equals(listid).toArray().then(sfs => {
				sfs.forEach(sf => {
					cache.set(sf.shortform, sf)
				})
			})

		})
	}

	shortforms.cache = cache
	return cache;
}
export function expandShortform(
	cache: Map<string, any>,
	ShortForm: string,
): string {
	const u = new Date();
	const shortform = ShortForm.toLowerCase();
	if (cache.has(shortform)) {
		const cachedShortform = cache.get(shortform);
		cachedShortform.used = u;
		cache.set(shortform, cachedShortform);

		if (shortform.match(/(\d+)/) || ShortForm === shortform) {
			return cachedShortform.phrase;
		} else if (ShortForm === shortform.toUpperCase() && ShortForm.length > 1) {
			return cachedShortform.phrase.toUpperCase();
		} else if (/^\p{Lu}(\p{L}*)/u.test(ShortForm)) {
			return cachedShortform.phrase.charAt(0).toUpperCase() + cachedShortform.phrase.substring(1);
		} else {
			return cachedShortform.phrase;
		}
	}
	return "";
}
